<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:binbraille_converter="grac:c#-code:binbraille_converter"
	xmlns:navigation_supporter="grac:c#-code:navigation_supporter"
	exclude-result-prefixes="binbraille_converter navigation_supporter">
	
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

	<xsl:template match="root">
		<xsl:copy>
			<xsl:apply-templates select="Page"/>
		</xsl:copy>
	</xsl:template>

	<xsl:template name="createNavigator">
		<xsl:param name="page_number"/>
		<Navigator>
			<html>
				<head>
					<title>123</title>
					<script language="javascript">
					function firstNavigator()
					{
						location.href = "<xsl:value-of select="concat('navigator', navigation_supporter:getFirst(),'.html')"/>";
					}
					function prevNavigator()
					{
						location.href = "<xsl:value-of select="concat('navigator', navigation_supporter:getPreviousFor($page_number),'.html')"/>";
					}
					function nextNavigator()
					{
						location.href = "<xsl:value-of select="concat('navigator', navigation_supporter:getNextFor($page_number),'.html')"/>";
					}
					function lastNavigator()
					{
						location.href = "<xsl:value-of select="concat('navigator', navigation_supporter:getLast(),'.html')"/>";
					}
					</script>
				</head>
				<body>
					<TABLE cellPadding="20">
						<TR>
							<TH>
								<xsl:choose>
									<xsl:when test="navigation_supporter:canMovePreviousFrom($page_number)">
										<a href="page1.html" target="page_content" onclick="firstNavigator()">
											<xsl:attribute name="href">
												<xsl:value-of select="concat('page', navigation_supporter:getFirst(),'.html')"/>
											</xsl:attribute>
										    first
                                        </a>
									</xsl:when>
									<xsl:otherwise>
										first
									</xsl:otherwise>
								</xsl:choose>
							</TH>
							<TH>
								<xsl:choose>
									<xsl:when test="navigation_supporter:canMovePreviousFrom($page_number)">
										<a target="page_content" onclick="prevNavigator()">
											<xsl:attribute name="href">
												<xsl:value-of select="concat('page', navigation_supporter:getPreviousFor($page_number),'.html')"/>
											</xsl:attribute>
											previous
										</a>
									</xsl:when>
									<xsl:otherwise>
										previous
									</xsl:otherwise>
								</xsl:choose>
							</TH>
							<TH>
								<b><xsl:value-of select="$page_number"/> from <xsl:value-of select=" navigation_supporter:getLast()"/></b>
							</TH>
							<TH>
								<xsl:choose>
									<xsl:when test="navigation_supporter:canMoveNextFrom($page_number)">
										<a target="page_content" onclick="nextNavigator()">
											<xsl:attribute name="href">
												<xsl:value-of select="concat('page', navigation_supporter:getNextFor($page_number),'.html')"/>
											</xsl:attribute>
											next
										</a>
									</xsl:when>
									<xsl:otherwise>
										next
									</xsl:otherwise>
								</xsl:choose>
							</TH>
							<TH>
								<xsl:choose>
									<xsl:when test="navigation_supporter:canMoveNextFrom($page_number)">
										<a target="page_content" onclick="lastNavigator()">
											<xsl:attribute name="href">
												<xsl:value-of select="concat('page', navigation_supporter:getLast(),'.html')"/>
											</xsl:attribute>
											last
										</a>
									</xsl:when>
									<xsl:otherwise>
										last
									</xsl:otherwise>
								</xsl:choose>
							</TH>
						</TR>
					</TABLE>
				</body>
			</html>
		</Navigator>
	</xsl:template>

	<xsl:template match="Page">
		<xsl:variable name="page_number" select="position()"/>
		<Page>
			<html>
				<head>
					<title>123</title>
					<meta http-equiv="Content-type" content="text/html; charset=utf-8"/>
               <link rel="stylesheet" type="text/css" href="style.css"></link>
				</head>
				<body>
					<!--p>Page <xsl:value-of select="$page_number"/>.</p-->
					<pre class="braille">
						<xsl:apply-templates select="Line"/>
					</pre>
				</body>
			</html>
		</Page>
		<xsl:call-template name="createNavigator">
			<xsl:with-param name="page_number" select="$page_number"/>
		</xsl:call-template>
	</xsl:template>

	<!-- first line -->
	<xsl:template match="Line[1]">
			<xsl:apply-templates select="br_atom"/><span>|</span>
	</xsl:template>
	<!-- not first line -->
	<xsl:template match="Line">
			<br/><xsl:apply-templates select="br_atom"/><span>|</span>
	</xsl:template>

	<xsl:template match="br_atom">
		<xsl:value-of select="binbraille_converter:convertBinBrailleValue2NativeEncodingValue(@value)"/>
	</xsl:template>

</xsl:stylesheet>
