<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html"/>
	
	<xsl:template match="/">
		<html>
		   <head>
		      <title>Running results</title>
		   </head>
		   <body>
		   	<ul>
					<h2>
						<xsl:apply-templates/>	
				   	<li>
							<xsl:choose>
								<xsl:when test="//Trace/@work_result = 'True'">
									The work performed successfully.
								</xsl:when>
								<xsl:otherwise>
									The work performed not at all.
								</xsl:otherwise>
							</xsl:choose>	
						</li>
					</h2>
				</ul>
		   </body>
		</html>
	</xsl:template>
	
	<xsl:template match="Step">
		<li>
			<xsl:value-of select="@name"/>
	   	<xsl:choose>
				<xsl:when test="warning or error">
					<h3>
				   	<ul>
							<xsl:apply-templates/>	
						</ul>
					</h3>
				</xsl:when>
				<xsl:otherwise>
					<h3>
						The step performed successfully.
					</h3>
				</xsl:otherwise>
			</xsl:choose>
		</li>
	</xsl:template>
	
	<xsl:template name="writeException">
		<li type="disc">
			<xsl:value-of select="local-name()"/>
		</li>
		<br/><xsl:value-of select="message"/>
		<xsl:if test="string-length(reason/text()) > 0">
			<br/><xsl:value-of select="' because'"/>
			<br/><xsl:value-of select="reason"/>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="warning">
   	<font color="green">
   		<xsl:call-template name="writeException"/>
		</font>
	</xsl:template>

	<xsl:template match="error">
   	<font color="red">
   		<xsl:call-template name="writeException"/>
		</font>
	</xsl:template>
	
</xsl:stylesheet>
