<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
										  xmlns:csharp-code="grac:c#-code"  
										  exclude-result-prefixes="csharp-code">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

	<xsl:template match="math">
		<xsl:copy>
			<xsl:apply-templates/>
		</xsl:copy>
	</xsl:template>

	<!-- process the next case:
	<menclose notation='updiagonalstrike'>
		<mo>text</mo>
	</menclose>
	the result is:
	<mo>text+/</mo>
	-->
	<xsl:template match="menclose[count(*)=1][mo][@notation='updiagonalstrike']">
		<mo><xsl:value-of select="concat(mo/text(), '/')"/></mo>
	</xsl:template>
	<!--
	transform
	<mo>&#x007c;</mo>
	<mo>&#x007c;</mo>
	into
	<mo>&#x2016;</mo>
	-->
	<xsl:template match="mo[text()='&#x007c;'][following-sibling::*[1][self::mo[text()='&#x007c;']]]">
		<mo>&#x2016;</mo>
	</xsl:template>
	<xsl:template match="mo[text()='&#x007c;'][preceding-sibling::*[1][self::mo[text()='&#x007c;']]]">
		<!-- do nothing -->
	</xsl:template>
	<!--
	transform
	<mo>:</mo>
	<mo>:</mo>
	into
	<mo>::</mo>
	-->
	<xsl:template match="mo[text()=':'][following-sibling::*[1][self::mo[text()=':']]]">
		<mo>::</mo>
	</xsl:template>
	<xsl:template match="mo[text()=':'][preceding-sibling::*[1][self::mo[text()=':']]]">
		<!-- do nothing -->
	</xsl:template>
	<!--
	transform
	<mi>&#x0025;</mi>
	into
	<mo>%</mo>
	-->
	<xsl:template match="mi[text()='&#x0025;']">
		<mo>%</mo>
	</xsl:template>
	<!--
	process mtext, parse into <mspace> and <mi>
	-->
	<xsl:template match="mtext">
		<xsl:copy-of select="csharp-code:parseText(text())"/>
	</xsl:template>
	<!--xsl:template match="mtext[(text()='&#x200B;') or (text()='&#x200A;') or (text()='&#x2009;') or (text()='&#x2009;&#x200A;&#x200A;') or (text()='&#x2003;')]">
		<mspace/>
	</xsl:template-->
	<!--
	process numbers. we should improve the markup like <mn>1.2,4.5</mn> 
	and get the next
	<mn>1.2</mn>
	<mo>,</mo>
	<mn>4.5</mn>
	-->
	<!--xsl:template match="mn">
		<xsl:choose>
			<xsl:when test="csharp-code:isUsualNumber(text())">
				<xsl:copy-of select="."/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy-of select="csharp-code:improveNumberMarkup(text())"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template-->
	
	<!--  change mtext by mi
	-->
	<!--xsl:template match="mtext">
		<mi><xsl:value-of select="text()"/></mi>
	</xsl:template-->
	
	<xsl:template match="*">
		<xsl:copy>
			<xsl:copy-of select="@*"/>
			<xsl:apply-templates/>
		</xsl:copy>
	</xsl:template>
	

</xsl:stylesheet>
