<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet SYSTEM "../Dictionaries/Common/Encoding/MathEntities.dtd">
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:csharp-code="grac:c#-code"  
	xmlns:typification="grac:typification"
	xmlns:m="http://www.w3.org/1998/Math/MathML"

   	xmlns:sys="http://www.blind.ru/grac_namespace"

	
	exclude-result-prefixes="typification csharp-code m msxsl sys">

	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

	<msxsl:script language="JScript" implements-prefix="sys">
		var u_number = 0; 
		function getUniqueNumber() { return u_number++; }
	</msxsl:script>



	<xsl:template name="createText">
		<xsl:value-of select="typification:textStarts()"/>
		<text>
			<xsl:value-of select="text()"/>
		</text>
	</xsl:template>

	<xsl:template name="createUnknown">
			<xsl:value-of select="typification:constantStarts()"/>
			<unknown>
			<!--unknown number='{sys:getUniqueNumber()}'-->
				<xsl:element name = '{concat("unknown", sys:getUniqueNumber())}' >
				      		<xsl:attribute name="sign">
							<xsl:value-of select="text()"/>
				      		</xsl:attribute>
				      		<xsl:attribute name="descr">
				      		</xsl:attribute>
				</xsl:element>
			</unknown>
	</xsl:template>


  			<!--	name = '{concat("unknown", {sys:getUniqueNumber()})}' -->

		<!--xsl:variable name="close_fence_name" select="csharp-code:getCodeByTerm('CloseBrackets',  text())"/>
		<xsl:if test="string-length($close_fence_name) > 0">
			<xsl:value-of select="typification:closeFenceStarts()"/>
			<close_fence>
				<xsl:element name="{$close_fence_name}"/>
			</close_fence>
		</xsl:if-->

				<!--xsl:element
  				name = "element-name"  
 				namespace = "uri-reference"
  				use-attribute-sets = QNames>
				</xsl:element-->



	
	<xsl:template match="/">
		<Result>
			<xsl:apply-templates select="m:math"/>
		</Result>
	</xsl:template>

	<xsl:template match="m:math">
		<xsl:for-each select="*">
			<xsl:value-of select="typification:expressionStarts()"/>
			<expression form='normal'>
				<xsl:value-of select="csharp-code:startToManageByAlphabetMarking()"/>
				<xsl:apply-templates select="current()"/>
			</expression>
		</xsl:for-each>
	</xsl:template>

	<xsl:template match="m:mrow">
		<xsl:apply-templates/>
	</xsl:template>

	<xsl:template match="m:mstyle">
		<xsl:apply-templates/>
	</xsl:template>

	<xsl:template match="m:menclose">
		<xsl:apply-templates/>
	</xsl:template>

	<xsl:template match="m:mn">
		<xsl:value-of select="typification:numberStarts()"/>
		<number type='crazy_number'>
			<xsl:copy-of select="csharp-code:createCrazyNumber(text())"/>
		</number>
		<!--xsl:choose>
			<xsl:when test="csharp-code:isNaturalNumber(text())">
				<xsl:value-of select="typification:numberStarts()"/>
				<number type='natural'>
					<digit-sequence>
						<xsl:copy-of select="csharp-code:createDigitSequence(text())"/>
					</digit-sequence>
				</number>
			</xsl:when>
			<xsl:when test="csharp-code:isDecimalFractionSeparatedWithDot(text())">
				<xsl:value-of select="typification:numberStarts()"/>
				<number type='decimal_fraction_dot'>
					<digit-sequence>
						<xsl:copy-of select="csharp-code:createDigitSequence(substring-before(text(), '.'))"/>
					</digit-sequence>
					<digit-sequence>
						<xsl:copy-of select="csharp-code:createDigitSequence(substring-after(text(), '.'))"/>
					</digit-sequence>
				</number>
			</xsl:when>
			<xsl:when test="csharp-code:isDecimalFractionSeparatedWithComma(text())">
				<xsl:value-of select="typification:numberStarts()"/>
				<number type='decimal_fraction_comma'>
					<digit-sequence>
						<xsl:copy-of select="csharp-code:createDigitSequence(substring-before(text(), ','))"/>
					</digit-sequence>
					<digit-sequence>
						<xsl:copy-of select="csharp-code:createDigitSequence(substring-after(text(), ','))"/>
					</digit-sequence>
				</number>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="typification:numberStarts()"/>
				<number type='untyped'>
					<value>
						<xsl:value-of select="text()"/>
					</value>
				</number>
			</xsl:otherwise>
		</xsl:choose-->
	</xsl:template>

	<!-- we have not to process this operator -->
	<xsl:template match="m:mo[text() = '&ApplyFunction;']"/>
	
	<xsl:template name="createOpenFence">
		<!-- ????? -->
		<xsl:variable name="open_fence_name" select="csharp-code:getCodeByTerm('OpenBrackets',  text())"/>
		<xsl:if test="string-length($open_fence_name) > 0">
			<xsl:value-of select="typification:openFenceStarts()"/>
			<open_fence>
				<xsl:element name="{$open_fence_name}"/>
			</open_fence>
		</xsl:if>
	</xsl:template>

	<xsl:template match="m:mo[@fence='true'][@form='postfix']">
		<xsl:call-template name="createCloseFence"/>
	</xsl:template>

	<xsl:template name="createCloseFence">
		<!-- ????? -->
		<xsl:variable name="close_fence_name" select="csharp-code:getCodeByTerm('CloseBrackets',  text())"/>
		<xsl:if test="string-length($close_fence_name) > 0">
			<xsl:value-of select="typification:closeFenceStarts()"/>
			<close_fence>
				<xsl:element name="{$close_fence_name}"/>
			</close_fence>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="m:mo[@fence='true'][@form='prefix']">
		<xsl:call-template name="createOpenFence"/>
	</xsl:template>


	<xsl:template match="m:mo">
		<xsl:variable name="system_name" select="csharp-code:getCodeByTerm('MathOperator', 'Arrows','Collection',  text())"/>
		<xsl:variable name="punct_name" select="csharp-code:getCodeByTerm('Punctuation', text())"/>
		<xsl:variable name="other_name" select="csharp-code:getCodeByTerm('Marks', 'ScriptBase', 'Brackets', 'Geometry', 'Miscellaneous',  text())"/>
		<xsl:choose>
			<xsl:when test="string-length($system_name) > 0">
				<!-- check it's an infix or a prefix operator -->
				<xsl:choose>
					<xsl:when test="@form = 'infix'">
						<xsl:variable name="operator">
							<operator>
								<xsl:element name="{$system_name}"/>
							</operator>
						</xsl:variable>
						<xsl:copy-of select="typification:typifyOperator($operator)"/>
					</xsl:when>
					<xsl:when test="@form = 'prefix'">
						<xsl:variable name="prefix-operator">
							<operator system_type='prefix'>
								<xsl:element name="{$system_name}"/>
							</operator>
						</xsl:variable>
						<xsl:copy-of select="typification:typifyOperator($prefix-operator)"/>
					</xsl:when>
					<xsl:when test="@form = 'postfix'">
						<xsl:variable name="postfix-operator">
							<operator system_type='postfix'>
								<xsl:element name="{$system_name}"/>
							</operator>
						</xsl:variable>
						<xsl:copy-of select="typification:typifyOperator($postfix-operator)"/>
					</xsl:when>
				</xsl:choose>
			</xsl:when>
			<xsl:when test="string-length($other_name) > 0">
				<xsl:variable name="other-operator">
					<operator system_type='other'>
						<xsl:element name="{$other_name}"/>
					</operator>
				</xsl:variable>
				<xsl:copy-of select="typification:typifyOtherOperator($other-operator)"/>
			</xsl:when>
			<xsl:when test="string-length($punct_name) > 0">
				<xsl:variable name="punctuation">
					<punctuation>
						<xsl:element name="{$punct_name}"/>
					</punctuation>
				</xsl:variable>
				<xsl:copy-of select="typification:typifyPunctuation($punctuation)"/>
			</xsl:when>
			<xsl:otherwise>
<!-- my
				<xsl:call-template name="createText"/-->

				<xsl:call-template name="createUnknown"/>
<!-- end of my-->
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="m:mi">
		<xsl:choose>
			<xsl:when test="csharp-code:checkCodeExists('MathFunctionName', text())">
				<xsl:value-of select="typification:mathFunctionStarts()"/>
				<math_function>
					<xsl:element name="{csharp-code:getCodeByTerm('MathFunctionName', text())}"/>
				</math_function>
			</xsl:when>
			<!--xsl:when test="following-sibling::m:mo[1][text() = '&ApplyFunction;']">
				<function>
					<Letter type="sequence">
						<xsl:copy-of select="csharp-code:createLetterSequence(text())"/>
					</Letter>
				</function>
			</xsl:when-->
			<xsl:when test="csharp-code:checkCodeExists('MathManifestConstant', text())">
				<xsl:value-of select="typification:constantStarts()"/>
				<const>
					<xsl:element name="{csharp-code:getCodeByTerm('MathManifestConstant', text())}"/>
				</const>
			</xsl:when>
			<xsl:otherwise><!-- it's an identifier -->
				<xsl:variable name="identifier">
					<identifier>
						<xsl:copy-of select="csharp-code:createLetterSequence(text(), .)"/>
					</identifier>
				</xsl:variable>
				<xsl:copy-of select="typification:typifyIdentifier($identifier)"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template match="m:mfrac">
		<xsl:variable name="fraction">
			<fraction>
				<xsl:value-of select="typification:numeratorStarts()"/>
				<numerator>
					<xsl:apply-templates select="*[1]"/>
				</numerator>
				<xsl:value-of select="typification:denominatorStarts()"/>
				<denominator>
					<xsl:apply-templates select="*[2]"/>
				</denominator>
			</fraction>
		</xsl:variable>

		<xsl:copy-of select="typification:typifyFraction($fraction)"/>
	</xsl:template>

	<xsl:template match="m:mroot">
		<xsl:variable name="root">
			<root>
				<xsl:value-of select="typification:rootBaseStarts()"/>
				<root_base>
					<xsl:apply-templates select="*[1]"/>
				</root_base>
				<xsl:value-of select="typification:rootIndexStarts()"/>
				<root_index>
					<xsl:apply-templates select="*[2]"/>
				</root_index>
			</root>
		</xsl:variable>

		<xsl:copy-of select="typification:typifyRoot($root)"/>
	</xsl:template>

	<xsl:template match="m:msqrt">
		<xsl:variable name="sqrt">
			<sqrt>
				<sqrt_base>
					<xsl:apply-templates select="*"/>
				</sqrt_base>
			</sqrt>
		</xsl:variable>

		<xsl:copy-of select="typification:typifySqrt($sqrt)"/>
	</xsl:template>
	
	<xsl:template match="m:msub">
		<xsl:variable name="script_star">
			<script_star>
				<xsl:value-of select="typification:scriptBaseStarts()"/>
				<script_base>
					<xsl:apply-templates select="*[1]"/>
				</script_base>
				<xsl:value-of select="typification:scriptRBStarts()"/>
				<script_rb>
					<xsl:apply-templates select="*[2]"/>
				</script_rb>
			</script_star>
		</xsl:variable>

		<xsl:copy-of select="typification:typifyScriptStar($script_star)"/>
	</xsl:template>

	<xsl:template match="m:msup">
		<xsl:variable name="script_star">
			<script_star>
				<xsl:value-of select="typification:scriptBaseStarts()"/>
				<script_base>
					<xsl:apply-templates select="*[1]"/>
				</script_base>
				<xsl:value-of select="typification:scriptRTStarts()"/>
				<script_rt>
					<xsl:apply-templates select="*[2]"/>
				</script_rt>
			</script_star>
		</xsl:variable>

		<xsl:copy-of select="typification:typifyScriptStar($script_star)"/>
	</xsl:template>

	<xsl:template match="m:msubsup">
		<xsl:variable name="script_star">
			<script_star>
				<xsl:value-of select="typification:scriptBaseStarts()"/>
				<script_base>
					<xsl:apply-templates select="*[1]"/>
				</script_base>
				<xsl:value-of select="typification:scriptRBStarts()"/>
				<script_rb>
					<xsl:apply-templates select="*[2]"/>
				</script_rb>
				<xsl:value-of select="typification:scriptRTStarts()"/>
				<script_rt>
					<xsl:apply-templates select="*[3]"/>
				</script_rt>
			</script_star>
		</xsl:variable>

		<xsl:copy-of select="typification:typifyScriptStar($script_star)"/>
	</xsl:template>

	<xsl:template match="m:munder">
		<xsl:variable name="script_star">
			<script_star>
				<xsl:value-of select="typification:scriptBaseStarts()"/>
				<script_base>
					<xsl:apply-templates select="*[1]"/>
				</script_base>
				<xsl:value-of select="typification:scriptUnderStarts()"/>
				<script_under>
					<xsl:apply-templates select="*[2]"/>
				</script_under>
			</script_star>
		</xsl:variable>

		<xsl:copy-of select="typification:typifyScriptStar($script_star)"/>
	</xsl:template>

	<xsl:template match="m:mover">
		<xsl:variable name="script_star">
			<script_star>
				<xsl:value-of select="typification:scriptBaseStarts()"/>
				<script_base>
					<xsl:apply-templates select="*[1]"/>
				</script_base>
				<xsl:value-of select="typification:scriptOverStarts()"/>
				<script_over>
					<xsl:apply-templates select="*[2]"/>
				</script_over>
			</script_star>
		</xsl:variable>

		<xsl:copy-of select="typification:typifyScriptStar($script_star)"/>
	</xsl:template>

	<xsl:template match="m:munderover">
		<xsl:variable name="script_star">
			<script_star>
				<xsl:value-of select="typification:scriptBaseStarts()"/>
				<script_base>
					<xsl:apply-templates select="*[1]"/>
				</script_base>
				<xsl:value-of select="typification:scriptUnderStarts()"/>
				<script_under>
					<xsl:apply-templates select="*[2]"/>
				</script_under>
				<xsl:value-of select="typification:scriptOverStarts()"/>
				<script_over>
					<xsl:apply-templates select="*[3]"/>
					<!--vertical_item>
						<xsl:apply-templates select="*[3]"/>
					</vertical_item-->
				</script_over>
			</script_star>
		</xsl:variable>

		<xsl:copy-of select="typification:typifyScriptStar($script_star)"/>
	</xsl:template>

	<xsl:template match="m:mmultiscripts[m:mprescripts]">
		<xsl:variable name="script_star">
			<script_star>
				<xsl:value-of select="typification:scriptBaseStarts()"/>
				<script_base>
					<xsl:apply-templates select="*[1]"/>
				</script_base>
				<xsl:if test="*[2][local-name(.) != 'mprescripts']"> <!-- the next 2 elements are sub and super postscripts -->
					<xsl:if test="*[2][local-name(.) != 'none']">
						<xsl:value-of select="typification:scriptRBStarts()"/>
						<script_rb>
							<xsl:apply-templates select="*[2]"/>
						</script_rb>
					</xsl:if>
					<xsl:if test="*[3][local-name(.) != 'none']">
						<xsl:value-of select="typification:scriptRTStarts()"/>
						<script_rt>
							<xsl:apply-templates select="*[3]"/>
						</script_rt>
					</xsl:if>
					<xsl:if test="*[5][local-name(.) != 'none']">
						<xsl:value-of select="typification:scriptLBStarts()"/>
						<script_lb>
							<xsl:apply-templates select="*[5]"/><!-- *[4] is mprescripts -->
						</script_lb>
					</xsl:if>
					<xsl:if test="*[6][local-name(.) != 'none']">
						<xsl:value-of select="typification:scriptLTStarts()"/>
						<script_lt>
							<xsl:apply-templates select="*[6]"/>
						</script_lt>
					</xsl:if>
				</xsl:if>
				<xsl:if test="*[3][local-name(.) != 'none']">
					<xsl:value-of select="typification:scriptLBStarts()"/>
					<script_lb>
						<xsl:apply-templates select="*[3]"/><!-- *[2] is mprescripts -->
					</script_lb>
				</xsl:if>
				<xsl:if test="*[4][local-name(.) != 'none']">
					<xsl:value-of select="typification:scriptLTStarts()"/>
					<script_lt>
						<xsl:apply-templates select="*[4]"/>
					</script_lt>
				</xsl:if>
			</script_star>
		</xsl:variable>

		<xsl:copy-of select="typification:typifyScriptStar($script_star)"/>
	</xsl:template>

	<!-- do not process an open fence before a table -->
	<xsl:template match="m:mo[@fence='true'][@form='prefix'][following-sibling::*[1][self::m:mtable]]"/>
	<!-- do not process a close fence after a table -->
	<xsl:template match="m:mo[@fence='true'][@form='postfix'][preceding-sibling::*[1][self::m:mtable]]"/>


	<!-- process an open fence for a table -->
	<xsl:template match="m:mo[@fence='true'][@form='prefix'][following-sibling::*[1][self::m:mtable]]" mode="for_table">
		<xsl:variable name="open_fence">
			<xsl:call-template name="createOpenFence"/>
		</xsl:variable>

		<xsl:value-of select="csharp-code:storeOpenFence($open_fence)"/>
 	</xsl:template>
	<!-- process a close fence for a table -->
	<xsl:template match="m:mo[@fence='true'][@form='postfix'][preceding-sibling::*[1][self::m:mtable]]" mode="for_table">
		<xsl:variable name="close_fence">
			<xsl:call-template name="createCloseFence"/>
		</xsl:variable>

		<xsl:value-of select="csharp-code:storeCloseFence($close_fence)"/>
	</xsl:template>
	
	<xsl:template match="m:mtable">
		<!-- find open and close fences for the table -->
		<xsl:apply-templates select="preceding-sibling::*[1]/self::m:mo[@fence='true'][@form='prefix']" mode="for_table"/>
		<xsl:apply-templates select="following-sibling::*[1]/self::m:mo[@fence='true'][@form='postfix']" mode="for_table"/>

		<xsl:variable name="table">
			<table>
				<xsl:copy-of select="csharp-code:getOpenFenceForTable()"/>
				<xsl:copy-of select="csharp-code:getCloseFenceForTable()"/>
				<xsl:for-each select="m:mtr">
					<xsl:value-of select="typification:tableRowStarts()"/>
					<table_row>
						<xsl:for-each select="m:mtd">
							<xsl:value-of select="typification:tableColumnStarts()"/>
							<table_column form='normal'>
								<xsl:apply-templates/>
							</table_column>
						</xsl:for-each>
					</table_row>
				</xsl:for-each>
			</table>
		</xsl:variable>

		<xsl:copy-of select="typification:typifyTable($table)"/>

		<xsl:value-of select="csharp-code:storeOpenFence()"/> <!-- init open fence holder -->
		<xsl:value-of select="csharp-code:storeCloseFence()"/> <!-- init close fence holder -->

	</xsl:template>

	<xsl:template match="m:mspace">
		<xsl:variable name="other-operator">
			<operator system_type='other'>
				<xsl:element name="space"/>
			</operator>
		</xsl:variable>
		<xsl:copy-of select="typification:typifyOtherOperator($other-operator)"/>
	</xsl:template>
	<!--- don't write a space between 2 number -->
	<xsl:template match="m:mspace[preceding-sibling::*[1][self::m:mn]][following-sibling::*[1][self::m:mn]]">
	</xsl:template>

	<xsl:template match="m:mtext">
		<xsl:call-template name="createText"/>
	</xsl:template>

	<!-- treat all undefined objects as a text -->
	<xsl:template match="*">
		<xsl:call-template name="createText"/>
		<xsl:apply-templates/>
	</xsl:template>
	
</xsl:stylesheet>
