<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
   xmlns:sys="http://www.blind.ru/grac_namespace"
   exclude-result-prefixes="sys msxsl">

	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

	<msxsl:script language="JScript" implements-prefix="sys">
		var u_number = 0; 
		function getUniqueNumber() { return u_number++; }
	</msxsl:script>

	<!--
		convert commands for a composite entity
	-->
	<xsl:template match="break_before" mode="for_composite_entity">
		<change_break_before number='{sys:getUniqueNumber()}'>
			<xsl:copy-of select="@*"/>
		</change_break_before>
	</xsl:template>

	<xsl:template match="break[@scope]" mode="for_composite_entity">
		<change_break  number='{sys:getUniqueNumber()}' for="{@scope}">
			<xsl:if test="@type">
				<xsl:attribute name="type">
					<xsl:value-of select="@type"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@priority">
				<xsl:attribute name="priority">
					<xsl:value-of select="@priority"/>
				</xsl:attribute>
			</xsl:if>
		</change_break>
	</xsl:template>
	
	<xsl:template match="break_after" mode="for_composite_entity">
		<change_latest_break number='{sys:getUniqueNumber()}'>
			<xsl:copy-of select="@*"/>
		</change_latest_break>
	</xsl:template>

	<xsl:template match="@hier_decrement" mode="for_composite_entity">
		<decrease_priority on='{.}' number='{sys:getUniqueNumber()}'/>
	</xsl:template>

	<xsl:template match="@can_ltrim['true']" mode="for_composite_entity">
		<can_ltrim/>
	</xsl:template>
	<!--
		convert commands for a simple entity
	-->
	<xsl:template match="break_before" mode="for_simple_entity">
		<change_break>
			<xsl:copy-of select="@*"/>
		</change_break>
	</xsl:template>

	<xsl:template match="break_after" mode="for_simple_entity">
		<xsl:copy-of select="@*"/>
	</xsl:template>

</xsl:stylesheet>
