<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
										  xmlns:csharp-code="grac:c#-code"
										  exclude-result-prefixes="csharp-code">

	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	
	<xsl:variable name="block_descriptor" select="csharp-code:getBlockDescriptionForExpression()"/>
	<!--
	create xsl-fo document with single block for each expression
	-->
	<xsl:template match="/">
		<root xmlns:fo="http://www.w3.org/1999/XSL/Format">
			<xsl:for-each select="//expression">
				<fo:block>
					<xsl:copy-of select="$block_descriptor"/>
					<xsl:apply-templates select="descendant::flow_atom"/>
				</fo:block>
			</xsl:for-each>
		</root>
	</xsl:template>
	
	<xsl:template match="flow_atom">
		<xsl:if test="count(br_atom) &gt; 0">
			<flow_atom>
				<xsl:copy-of select="@*"/>
				<xsl:copy-of select="br_atom"/>
			</flow_atom>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>